// File multiple_shapes.scad
// Creates shapes of n sides to fit into an area x by y
// (c) 2023 Rich Cameron, for the book Make:Trigonometry
// Licensed under a Creative Commons, Attribution,
// CC-BY 4.0 international license, per
// https://creativecommons.org/licenses/by/4.0/
// Attribute to Rich Cameron, at
// repository github.com/whosawhatsis/Trigonometry

s = 20; // length of a side, mm
n = 4; // number of sides
t = 2; // thickness in mm - set to 0 for 2D
x = 200; // x dimension of paper or print bed
y = 200; // y dimension of paper or print bed

for(
  x = [0:s / sin(180 / n) + 1:x - s / sin(180 / n)],
  y = [0:s / sin(180 / n) + 1:y - s / sin(180 / n)]
)
  translate([x, y]) rotate(180 / n)
  if(t) cylinder(r = s / (2 * sin(180 / n)), h = t, $fn = n);
  else circle(s / (2 * sin(180 / n)), $fn = n);

